"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EmojiSuggest = EmojiSuggest;
exports.EmojiSuggestContainer = EmojiSuggestContainer;

var _reactDom = _interopRequireDefault(require("react-dom"));

var _react = _interopRequireWildcard(require("react"));

var _react2 = require("@bangle.dev/react");

var _emojiSuggest = require("./emoji-suggest");

var _utils = require("./utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function EmojiSuggest(_ref) {
  var {
    emojiSuggestKey
  } = _ref;
  var {
    counter,
    triggerText,
    show: isVisible
  } = (0, _react2.usePluginState)((0, _emojiSuggest.getSuggestTooltipKey)(emojiSuggestKey));
  var view = (0, _react2.useEditorViewContext)();
  var {
    tooltipContentDOM,
    getEmojiGroups,
    maxItems,
    squareSide,
    squareMargin,
    rowWidth,
    palettePadding,
    selectedEmojiSquareId
  } = (0, _react2.usePluginState)(emojiSuggestKey);
  return /*#__PURE__*/_reactDom.default.createPortal( /*#__PURE__*/_react.default.createElement("div", {
    className: "bangle-emoji-suggest",
    style: {
      padding: palettePadding
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    style: {
      width: rowWidth,
      display: 'flex',
      justifyContent: 'center'
    }
  }, isVisible && /*#__PURE__*/_react.default.createElement(EmojiSuggestContainer, {
    view: view,
    rowWidth: rowWidth,
    squareMargin: squareMargin,
    squareSide: squareSide,
    emojiSuggestKey: emojiSuggestKey,
    getEmojiGroups: getEmojiGroups,
    maxItems: maxItems,
    triggerText: triggerText,
    counter: counter,
    selectedEmojiSquareId: selectedEmojiSquareId
  }))), tooltipContentDOM);
}

function EmojiSuggestContainer(_ref2) {
  var {
    view,
    rowWidth,
    squareMargin,
    squareSide,
    emojiSuggestKey,
    getEmojiGroups,
    triggerText,
    counter,
    selectedEmojiSquareId
  } = _ref2;
  var emojiGroups = (0, _react.useMemo)(() => getEmojiGroups(triggerText), [getEmojiGroups, triggerText]);
  var {
    containerWidth
  } = (0, _utils.getSquareDimensions)({
    rowWidth,
    squareMargin,
    squareSide
  });
  var {
    item: activeItem
  } = (0, _utils.resolveCounter)(counter, emojiGroups);
  var onSelectEmoji = (0, _react.useCallback)(emojiAlias => {
    (0, _emojiSuggest.selectEmoji)(emojiSuggestKey, emojiAlias)(view.state, view.dispatch, view);
  }, [view, emojiSuggestKey]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "bangle-emoji-suggest-container",
    style: {
      width: containerWidth
    }
  }, emojiGroups.map((_ref3, i) => {
    var {
      name: groupName,
      emojis
    } = _ref3;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "bangle-emoji-suggest-group",
      key: groupName || i
    }, groupName && /*#__PURE__*/_react.default.createElement("span", null, groupName), /*#__PURE__*/_react.default.createElement("div", null, emojis.map((_ref4, j) => {
      var [emojiAlias, emoji] = _ref4;
      return /*#__PURE__*/_react.default.createElement(EmojiSquare, {
        key: emojiAlias,
        isSelected: activeItem[0] === emojiAlias,
        emoji: emoji,
        emojiAlias: emojiAlias,
        onSelectEmoji: onSelectEmoji,
        selectedEmojiSquareId: selectedEmojiSquareId,
        style: {
          margin: squareMargin,
          width: squareSide,
          height: squareSide,
          lineHeight: squareSide + 'px',
          fontSize: Math.max(squareSide - 7, 4)
        }
      });
    })));
  }));
}

function EmojiSquare(_ref5) {
  var {
    isSelected,
    emoji,
    emojiAlias,
    onSelectEmoji,
    style,
    selectedEmojiSquareId
  } = _ref5;
  return /*#__PURE__*/_react.default.createElement("button", {
    className: "bangle-emoji-square ".concat(isSelected ? 'bangle-is-selected' : ''),
    id: isSelected ? selectedEmojiSquareId : undefined,
    onClick: e => {
      e.preventDefault();
      onSelectEmoji(emojiAlias);
    },
    style: style
  }, emoji);
}